//
//  FirstViewController.m
//  iGEMPartSearch
//
//  Created by Dinula on 4/15/2014.
//  Copyright (c) 2014 Lethrbridge High School iGEM Team. All rights reserved.
//

#import "FirstViewController.h"
#import "resultsViewController.h"

@interface FirstViewController ()

@end

@implementation FirstViewController
@synthesize authorLabel;
@synthesize queryBox;
@synthesize scrollView;
@synthesize tempString;
@synthesize infoScroller;
@synthesize partInfo;
@synthesize partNameLabel;
@synthesize downloadsView;

- (void)viewDidLoad
{
    authString = [[NSMutableString alloc] init];
    scrollView = [[UIScrollView alloc] init];
    tempString = [[NSMutableString alloc]init];
    [tempString setString:@"hello"];
    paragraph = [[NSMutableString alloc] init];
    
     calledPartAuthor = YES;
     calledPartShortName = YES;
     calledPartShortDesc = YES;
     calledPartType = YES;
     calledPartResults = YES;
     calledPartSeqData = YES;
     calledPartSampleStatus = YES;
    
    stringS = [[NSMutableAttributedString alloc] initWithString:@"Approximate Distance: 120m away"];
    NSRange selectedRange = NSMakeRange(22, 4); // 4 characters, starting at index 22
    
    [stringS beginEditing];
    
    [stringS addAttribute:NSFontAttributeName
                   value:[UIFont fontWithName:@"Helvetica-Bold" size:12.0]
                   range:selectedRange];
    
    [stringS endEditing];
    queryBox.delegate = self;
    
    
    [self setupInterface];
    [super viewDidLoad];
	// Do any additional setup after loading the view, typically from a nib.
    isOnPage = NO;
}
- (void)applicationDidBecomeActive:(UIApplication*)application
{
    
}
-(void)setupInterface{
    CGSize screenSize = [[UIScreen mainScreen] bounds].size;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if (screenSize.height > 480.0f){
            partInfo.frame = CGRectMake(350, 35, 299, 250);
           // infoScroller.frame = CGRectMake(318, 1029, 668, 906);
            //iphone 5
        }
        else{
            //normal
            partInfo.frame = CGRectMake(350, 35, 299, 250);
            //infoScroller.frame = CGRectMake(-18, 215, infoScroller.frame.size.width, infoScroller.frame.size.height);
            //[infoScroller setContentOffset:CGPointMake(0, 30) animated:NO];
        }
    }
    
}

- (void)didReceiveMemoryWarning
{
    [super didReceiveMemoryWarning];
    // Dispose of any resources that can be recreated.
}
-(void)registerForKeyboardNotifications{
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWasShown:) name:UIKeyboardDidShowNotification object:nil];
    [[NSNotificationCenter defaultCenter] addObserver:self selector:@selector(keyboardWillBeHidden:) name:UIKeyboardDidHideNotification object:nil];
}
-(void)deregisterFromKeyboardNotifications{
    [[NSNotificationCenter defaultCenter] removeObserver:self name:UIKeyboardDidHideNotification object:nil];
    [[NSNotificationCenter defaultCenter]removeObserver:self name:UIKeyboardWillHideNotification object:nil];
}
-(void)viewWillAppear:(BOOL)animated{
    [super viewWillAppear:animated];
    [self registerForKeyboardNotifications];
}
-(void)viewWillDisappear:(BOOL)animated{
    [self deregisterFromKeyboardNotifications];
    [super viewWillDisappear:animated];
}
-(void)keyboardWasShown:(NSNotification *)notification{
    NSLog(@"hi");
    queryBox.text = @"";
    NSDictionary* info = [notification userInfo];
    
    CGSize keyboardSize = [[info objectForKey:UIKeyboardFrameBeginUserInfoKey] CGRectValue].size;
    
    CGPoint textInputOrigin = queryBox.frame.origin;
    
    CGFloat textInputHeight = queryBox.frame.size.height;
    
    CGRect visibleRect = self.view.frame;
    
    visibleRect.size.height -= keyboardSize.height;
        
        CGPoint scrollPoint = CGPointMake(0.0, textInputOrigin.y - visibleRect.size.height + textInputHeight);
        
        //[scrollView setContentOffset:CGPointMake(0, 100) animated:YES];
        [UIView beginAnimations:nil context:NULL];
        [UIView setAnimationDuration:0.25];
    
    
   /* CGSize screenSize = [[UIScreen mainScreen] bounds].size;
    if (UI_USER_INTERFACE_IDIOM() == UIUserInterfaceIdiomPhone){
        if (screenSize.height > 480.0f){
            
            self.view.frame = CGRectMake(0, -75, self.view.frame.size.width, self.view.frame.size.height);
          //iphone 5
        }
        else{
           //normal
            
            self.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
            
        }*/
    
    [self.view setFrame:CGRectMake(0,-80,320,460)];



        
    
}
-(void)keyboardWillBeHidden:(NSNotification *)notification{
    [UIView beginAnimations:nil context:NULL];
    [UIView setAnimationDuration:0.25];
    self.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
}
- (BOOL)textFieldShouldReturn:(UITextField *)textField
{
    [textField resignFirstResponder];
    
    return YES;
}

- (IBAction)searchUpPart:(id)sender {

    NSMutableString *string;
    string = [NSMutableString stringWithFormat:@"http://parts.igem.org/cgi/xml/part.cgi?part=%@.xml", queryBox.text];
    NSLog(@"string : %@", string);
    partName = queryBox.text;
    queryBox.text = nil;
    NSURL *url;
    url = nil;
    url = [NSURL URLWithString:string];
    
    NSData *data = nil;
    data = [NSData dataWithContentsOfURL:url];

    
        NSXMLParser *iGEMParser  = [[NSXMLParser alloc] initWithData:data];
    
    [iGEMParser setDelegate:self];
    [iGEMParser parse];
    
    BOOL success = [iGEMParser parse];
    if (success){
        NSLog(@"scuss");
       
    }
    else{
      //   authorLabel.text = authString;
        NSLog(@"fail");
        [iGEMParser abortParsing];
    }
    [infoScroller setContentOffset:CGPointMake(320, 0) animated:YES];
    self.view.frame = CGRectMake(0, 0, self.view.frame.size.width, self.view.frame.size.height);
    [self.view endEditing:YES];
    isOnPage = YES;
    
}

- (IBAction)scrollToSearch:(id)sender {
    if (isOnPage == YES){
    [infoScroller setContentOffset:CGPointMake(0, 0) animated:YES];
    [self viewDidLoad];
    [self viewWillAppear:YES];
        isOnPage = NO;
}
}

- (IBAction)downloadPart:(id)sender {
    //////create xml//////
    /****reading the plist*******/
    /*NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES);
    NSString *documentsPath = [paths objectAtIndex:0];
    NSString *plistPath = [documentsPath stringByAppendingString:@"partsData.plist"];
    
    NSData *plistXML = [[NSFileManager defaultManager] contentsAtPath:plistPath];
    NSString *errorDesc = nil;
    NSPropertyListFormat format;
    NSDictionary *temp = (NSDictionary *)[NSPropertyListSerialization propertyListFromData:plistXML mutabilityOption:NSPropertyListMutableContainersAndLeaves format:&format errorDescription:&errorDesc];
    if (!temp){
        NSLog(@"error reading plist");
    }*/
    
    NSError *error;
    NSArray *paths = NSSearchPathForDirectoriesInDomains(NSDocumentDirectory, NSUserDomainMask, YES); //1
    NSString *documentsDirectory = [paths objectAtIndex:0]; //2
    NSString *path = [documentsDirectory stringByAppendingPathComponent:@"data.plist"]; //3
    
    NSFileManager *fileManager = [NSFileManager defaultManager];
    
    if (![fileManager fileExistsAtPath: path]) //4
    {
        NSString *bundle = [[NSBundle mainBundle] pathForResource:@"Part" ofType:@"plist"]; //5
        
        [fileManager copyItemAtPath:bundle toPath: path error:&error]; //6
        
    }
    }

- (IBAction)switchSceneToDownloads:(id)sender {
    [infoScroller setContentOffset:CGPointMake(0, -600) animated:YES];
}

- (IBAction)openHelpScreen:(id)sender {
    [infoScroller setContentOffset:CGPointMake(-315, 0) animated:YES];
    isOnPage = YES;
}
-(void)scrollToSearch{
    
}
-(void)setDataValues{

    [partNameLabel setText:partName];
    [partInfo setText:paragraph];
    NSLog(@"auth string length: %d", [authString length]);
    
    NSLog(@"auth string %@", authString);
    if ([authString length]==0){
        [partInfo setText:@"Please try entering part name again by cliking the Search button above. You may have misspelled the part name."];
        [partNameLabel setText:@"Part Not Found"];
    }
    
}
- (void)parser:(NSXMLParser *)parser didStartElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qualifiedName attributes:(NSDictionary *)attributeDict{
    //NSLog(@"called");
    if ([elementName isEqualToString:@"rsbpml"]){
//        NSLog(@"1");
                     }
    if ([elementName isEqualToString:@"part_list"]){
  //      NSLog(@"2");
    }
    if ([elementName isEqualToString:@"part"]){
    //    NSLog(@"3");
    }
    if ([elementName isEqualToString:@"part_id"]){
      //  NSLog(@"4");
        //NSLog(@"%@", elementName);
        
    }
          }


-(void)parser:(NSXMLParser *)parser foundCharacters:(NSString *)string{
    curElementValue = [[NSMutableString alloc] initWithString:string];
        NSLog(@"called %@", curElementValue);
    
}

-(void)parser:(NSXMLParser *)parser didEndElement:(NSString *)elementName namespaceURI:(NSString *)namespaceURI qualifiedName:(NSString *)qName{
        NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
    if ([elementName isEqualToString:@"part_author"]){
        if (calledPartAuthor){
        authString = curElementValue;
            [defaults setObject:authString forKey:@"part_string"];
        [paragraph appendFormat:@"Author: %@ \n", authString];
            
            
            calledPartAuthor = NO;
        }
    }
    if ([elementName isEqualToString:@"part_short_name"]){
        if (calledPartShortName){
        shortName = curElementValue;
        [defaults setObject:shortName forKey:@"short_Name"];
        [paragraph appendFormat:@"Short Name: %@ \n", shortName];
            calledPartShortName = NO;
        }
    }
    if ([elementName isEqualToString:@"part_short_desc"]){
        if (calledPartShortDesc){
        shortDescription = curElementValue;
        [defaults setObject:shortName forKey:@"short_Des"];
        [paragraph appendFormat:@"Description: %@ \n", shortDescription];
            calledPartShortDesc = NO;
        }
    }
    if ([elementName isEqualToString:@"part_type"]){
        if (calledPartType){
        partType = curElementValue;
        [defaults setObject:shortName forKey:@"part_type"];
        [paragraph appendFormat:@"Part Type: %@ \n", partType];
            calledPartType = NO;
        }
    }
    if ([elementName isEqualToString:@"part_results"]){
        if (calledPartResults){
        partResults = curElementValue;
        [defaults setObject:shortName forKey:@"part_results"];
        [paragraph appendFormat:@"Part Results: %@ \n", partResults];
            calledPartResults = NO;
        }
    }
    if ([elementName isEqualToString:@"seq_data"]){
        if (calledPartSeqData){
        sequenceValue = curElementValue;
                [defaults setObject:sequenceValue forKey:@"part_sequence"];
        
        [paragraph appendFormat:@"Part Sequence: %@ \n", sequenceValue];
        
        //////calculate base pairs///////
        int basePairs = [sequenceValue length]-1;
        [defaults setInteger:basePairs forKey:@"part_length"];
        
        [paragraph appendFormat:@"Length: %dp \n", basePairs];
            calledPartSeqData = NO;
        //////END*********/////////////////
        }
    }
    if ([elementName isEqualToString:@"sample_status"]){
        if (calledPartSampleStatus){
        stockString = curElementValue;
            [defaults setObject:stockString forKey:@"part_stock"];
       
        [paragraph appendFormat:@"Stock: %@ \n", stockString];
            calledPartSampleStatus = NO;
        }
    }
    if ([elementName isEqualToString:@"part_results"]){
        if (calledPartResults){
        testedString = curElementValue;
        [defaults setObject:stockString forKey:@"part_works"];
        [paragraph appendFormat:@"Tested: %@p \n", testedString];
            calledPartResults = NO;
        }
    }
    [self setDataValues];
}

@end
