//
//  resultsViewController.m
//  iGEMPartSearch
//
//  Created by Dinula on 4/22/2014.
//  Copyright (c) 2014 Lethrbridge High School iGEM Team. All rights reserved.
//

#import "resultsViewController.h"
#import "FirstViewController.h"

@implementation resultsViewController

-(void)viewDidLoad{
    [self setValuesForParts];
    UILabel *authLabel = [[UILabel alloc] initWithFrame:CGRectMake(20, 20, 280, 150)];
    [authLabel setFont:[UIFont fontWithName:@"ArialMT" size:15]];
    [authLabel setText:[NSString stringWithFormat:@"Author: %@", authString]];
    [self.view addSubview:authLabel];
  
    UILabel *sequenceLabel = [[UILabel alloc] initWithFrame:CGRectMake(20, 60, 280, 150)];
    [sequenceLabel setFont:[UIFont fontWithName:@"ArialMT" size:15]];
    [sequenceLabel setText:[NSString stringWithFormat:@"Sequence: %@", sequenceString]];
    [self.view addSubview:sequenceLabel];
    
    UILabel *basePairsLabel = [[UILabel alloc] initWithFrame:CGRectMake(20, 100, 280, 150)];
    [basePairsLabel setFont:[UIFont fontWithName:@"ArialMT" size:15]];
    [basePairsLabel setText:[NSString stringWithFormat:@"Length: %d bp", basePairs]];
    [self.view addSubview:basePairsLabel];
    
    UILabel *stockLabel = [[UILabel alloc] initWithFrame:CGRectMake(20, 140, 280, 150)];
    [stockLabel setFont:[UIFont fontWithName:@"ArialMT" size:15]];
    [stockLabel setText:[NSString stringWithFormat:@"Availability: %@", stockString]];
    [self.view addSubview:stockLabel];
    
    UILabel *testedLabel = [[UILabel alloc] initWithFrame:CGRectMake(20, 140, 280, 150)];
    [testedLabel setFont:[UIFont fontWithName:@"ArialMT" size:15]];
    [testedLabel setText:[NSString stringWithFormat:@"Availability: %@", testedString ]];
    [self.view addSubview:testedLabel];
}


-(void)setValuesForParts{
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
     sequenceString = [defaults objectForKey:@"part_sequence"];
    authString = [defaults objectForKey:@"part_string"];
    basePairs = [defaults integerForKey:@"part_length"];
    stockString = [defaults objectForKey:@"part_stock"];
    testedString = [defaults objectForKey:@"part_works"];
}


@end
